from vcCommand import *
app = getApplication()

def SelectComponents(args):
  global apply_prop, matchCase, searchWord, excludeEnabled, excludeFilters
  sm = app.SelectionManager
  sm.clear()
  excMessage = ''
  if excludeEnabled.Value and excludeFilters.Value:
    excMessage = ', but not "{0}" '.format(excludeFilters.Value)
  print 'Selecting components which have "{0}" {1} in their name.'.format(searchWord.Value,excMessage)
  results = []
  excludes = []
  filteredCount = 0
  if searchWord.Value != '':
    for icomp in app.Components:
      icompName = icomp.Name
      searchString = str(searchWord.Value)
      excludeString = str(excludeFilters.Value)

      # If MatchCase not in use, let's make the strings to lowercase
      if not matchCase.Value:
        searchString = searchString.lower()
        icompName = icompName.lower()      
        
      # Find the components which have the search word
      if searchString in icompName:
        results.append(icomp)

      # If exclude filter enabled, add the component in the filtering list
      if excludeEnabled.Value and excludeFilters.Value:
        for excludeFilter in excludeFilters.Value.split(','):
          if not matchCase.Value:
            excludeFilter = excludeFilter.lower()
          if excludeFilter in icompName:
            excludes.append(icomp)

    # Select the results which are not excluded
    for r in results:
      if r in excludes:
        filteredCount += 1
      else:
        sm.setSelection(r,True)
  
    output =  "{0} components selected".format(len(sm.getSelection(VC_SELECTION_COMPONENT))) 
    if excludeEnabled.Value and excludeFilters.Value:
      output += ", {0} components filtered".format(filteredCount) 
    print output
    app.render()    

def first_state():
  global apply_prop, matchCase, searchWord, excludeEnabled, excludeFilters
  cmd = getCommand()
  for p in cmd.Properties:
    deleteProperty(p)

  group = 0
  searchWord = createProperty(VC_STRING, 'SearchWord')
  searchWord.Group = group = group + 10
  excludeEnabled = createProperty(VC_BOOLEAN,'ExcludeFilterEnabled')
  excludeEnabled.Group = group = group + 10
  excludeFilters = createProperty(VC_STRING, 'ExcludeFilters')
  excludeFilters.Group = group = group + 10
  matchCase = createProperty(VC_BOOLEAN,'MatchCase')
  matchCase.Group = group = group + 10
  # button to execute the command
  apply_prop = createProperty(VC_BUTTON, 'Apply')
  apply_prop.Group = group = group + 10
  apply_prop.OnChanged = SelectComponents     
  executeInActionPanel()

addState(first_state)